Imports System.Xml
Imports System.Xml.Serialization
Imports System.IO
Imports System.Text.Encoding

Namespace Demo
    Public Class util

        ''' <summary>
        ''' this function will serialize a class to a string of xml data
        ''' </summary>
        ''' <param name="O"></param>
        ''' <param name="OType"></param>
        ''' <returns></returns>
        ''' <remarks></remarks>
        Public Shared Function GetXml(ByVal O As Object, ByVal OType As Type) As String
            'instantiate the xmlserializer object and tell it that the type we want is of type (your object type)
            'In this instance I am passing the type to the function so I use OType to represenet my objects type which is People.
            Dim XS As New XmlSerializer(OType)

            'Instantiate the xmltextreader object and then tell it that it will be writing to a new memory stream with UTF8 encoding
            Dim XMLTW As New XmlTextWriter(New MemoryStream, UTF8)
            XMLTW.Formatting = Formatting.Indented

            Dim XmlString As String
            Dim ms As MemoryStream

            'call serialize and pass in the xmltextwriter object and our object (PeopleCollection as declared on main form)
            XS.Serialize(XMLTW, O)

            'get the base stream of the xmltext writer and assign it to a memory stream
            ms = XMLTW.BaseStream
            XMLTW.Close() 'close out the xmltextwriter

            'use the getstring method of the encoding type to read in the byte array of the memory stream and construct a string.
            XmlString = UTF8.GetString(ms.ToArray())
            ms.Close() 'close the memory stream


            'return the string
            Return XmlString

        End Function
    End Class
End Namespace

